      SUBROUTINE RECEIVE_DATA_ASSEMBLE5(CONNID,ne,ELEM,LGE,NHST,ES,
     '  PROC_TIME,ERROR,*)

C#### Subroutine: RECEIVE_DATA_ASSEMBLE5
C###  Description:
C###    RECEIVE_DATA_ASSEMBLE5 performs parallel processing for
C###    ASSEMBLE5. Receives results from slave
C###    process that calculates element stiffness matrices.
C**** NOTE: changes to this code must be reflected in FE_PARALLEL.F

      IMPLICIT NONE
      INCLUDE 'geom00.cmn'
      INCLUDE 'fsklib.inc'
!     Parameter List
      INTEGER CONNID,LGE(NHM*NSM,NRCM),ne,NHST(*)
      REAL*8 ES(NHM*NSM,NHM*NSM),PROC_TIME
      LOGICAL ELEM
      CHARACTER ERROR*(*)
!     Local Variables
      INTEGER nhs,nrc

      CALL ENTERS('RECEIVE_DATA_ASSEMBLE5',*9999)

      IF(FSKREAD(ne,SK_LONG_INT,1,CONNID).EQ.-1) GOTO 9999
      IF(FSKREAD(ELEM,SK_LONG_INT,1,CONNID).EQ.-1) GOTO 9999
      IF(FSKREAD(NHST,SK_LONG_INT,2,CONNID).EQ.-1) GOTO 9999
      DO nrc=1,NRCM
        IF(FSKREAD(LGE(1,nrc),SK_LONG_INT,NHST(1),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO nhs=1,NHST(2)
        IF(FSKREAD(ES(1,nhs),SK_DOUBLE_FLOAT,NHST(1),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      IF(FSKREAD(PROC_TIME,SK_DOUBLE_FLOAT,1,CONNID).EQ.-1) GOTO 9999

      CALL EXITS('RECEIVE_DATA_ASSEMBLE5')
      RETURN
 9999 ERROR='>>Socket Error'
      CALL ERRORS('RECEIVE_DATA_ASSEMBLE5',ERROR)
      CALL EXITS('RECEIVE_DATA_ASSEMBLE5')
      RETURN 1
      END


