      SUBROUTINE SEND_ARRAYS_ASSEMBLE5(CONNID,IBT,IDO,INP,NAN,NBH,
     '  NBJ,NBJF,NFF,NGAP,NHE,NHP,NKEF,NKH,NMNO,NNF,NPF,NPNE,
     '  NPNY,NRE,NVHE,NVHP,NW,NXI,NYNE,NYNP,CE,CP,PG,SE,WG,FIX,
     '  ERROR,*)

C#### Subroutine: SEND_ARRAYS_ASSEMBLE5
C###  Description:
C###    SEND_ARRAYS_ASSEMBLE5 performs parallel processing for
C###    ASSEMBLE5. Passes global arrays to
C###    element stiffness matrix calculating slave process.
C**** NOTE: changes to this code must be reflected in FE_PARALLEL.F

      IMPLICIT NONE
      INCLUDE 'fsklib.inc'
      INCLUDE 'geom00.cmn'
      INCLUDE 'loc00.cmn'
      INCLUDE 'loc00.inc'
      INCLUDE 'opti00.cmn'
!     Parameter List
      INTEGER CONNID,
     '  IBT(3,NIM,NBFM),IDO(NKM,NNM,0:NIM,NBFM),INP(NNM,NIM,NBFM),
     '  NAN(NIM,NAM,NBFM),NBH(NHM,NCM,NEM),NBJ(NJM,NEM),NBJF(NJM,NFM),
     '  NFF(6,NEM),NGAP(NIM,NBM),NHE(NEM),NHP(NPM,0:NRM),
     '  NKEF(0:4,16,6,NBFM),
     '  NKH(NHM,NPM,NCM,0:NRM),NMNO(1:2,0:NOPM),NNF(0:17,6,NBFM),
     '  NPF(9,NFM),
     '  NPNE(NNM,NBFM,NEM),NPNY(0:6,NYM,0:NRCM),NRE(NEM),
     '  NVHE(NNM,NBFM,NHM,NEM),NVHP(NHM,NPM,NCM,0:NRM),
     '  NW(NEM,3),NXI(-NIM:NIM,0:NEIM,0:NEM),
     '  NYNE(NAM,NHM,0:NRCM,NCM,NEM),
     '  NYNP(NKM,NVM,NHM,NPM,0:NRCM,NCM,NRM)
      REAL*8 CE(NMM,NEM),CP(NMM,NPM),PG(NSM,NUM,NGM,NBM),
     '  SE(NSM,NBFM,NEM),WG(NGM,NBM)
      CHARACTER ERROR*(*)
      LOGICAL FIX(NYM,NIYFIXM)
!     Local Variables
      INTEGER kk,L,mm,na,nb,nc,ne,nef,nf,ng,nh,ni,nn,
     '  np,nr,nrc,nu,nv,ny,
     '  TEMP_STR_C(18)
      CHARACTER TEMP_STR*18

      CALL ENTERS('SEND_ARRAYS_ASSEMBLE5',*9999)

C *** Integer Arrays
      IF(FSKWRITE(NHE,SK_LONG_INT,NET(0),CONNID).EQ.-1) GOTO 9999
      DO nr=0,NRT
        IF(FSKWRITE(NHP(1,nr),SK_LONG_INT,NPT(nr),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO !nr
      DO nr=1,NRT
        IF(FSKWRITE(NJ_LOC(NJL_GEOM,0,nr),SK_LONG_INT,NET(0),CONNID).EQ.
     '    -1) GOTO 9999
      ENDDO
      DO nb=1,NBFT
        DO ni=1,NIT(nb)
          IF(FSKWRITE(IBT(1,ni,nb),SK_LONG_INT,3,CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO
      ENDDO
      DO nb=1,NBFT
        DO ni=0,NIT(nb)
          DO nn=1,NNT(nb)
            IF(FSKWRITE(IDO(1,nn,ni,nb),SK_LONG_INT,NKT(nn,nb),CONNID)
     '        .EQ.-1) GOTO 9999
          ENDDO
        ENDDO
      ENDDO
      DO nb=1,NBFT
        DO ni=1,NIT(nb)
          IF(FSKWRITE(INP(1,ni,nb),SK_LONG_INT,NNT(nb),CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO
      ENDDO
      DO nb=1,NBFT
        DO na=1,NAT(nb)
          IF(FSKWRITE(NAN(1,na,nb),SK_LONG_INT,NIT(nb),CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO
      ENDDO
      DO ne=1,NET(0)
        DO nc=1,NCM
          IF(FSKWRITE(NBH(1,nc,ne),SK_LONG_INT,NH_LOC(0,0),CONNID)
     '      .EQ.-1) GOTO 9999
        ENDDO
      ENDDO
      DO ne=1,NET(0)
        IF(FSKWRITE(NBJ(1,ne),SK_LONG_INT,NJ_LOC(0,0,0),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO nf=1,NFT
        IF(FSKWRITE(NBJF(1,nf),SK_LONG_INT,NJ_LOC(0,0,0),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO ne=1,NET(0)
        IF(FSKWRITE(NFF(1,ne),SK_LONG_INT,6,CONNID).EQ.-1) GOTO 9999
      ENDDO
      DO nb=1,NBT
        IF(FSKWRITE(NGAP(1,nb),SK_LONG_INT,NIT(nb),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO nb=1,NBFT
        DO mm=1,6
          DO kk=1,16
            IF(FSKWRITE(NKEF(0,kk,mm,nb),SK_LONG_INT,5,CONNID).EQ.-1)
     '        GOTO 9999
          ENDDO
        ENDDO
      ENDDO
      DO nr=0,NRT
        DO nc=1,NCM
          DO np=1,NPT(nr)
            IF(FSKWRITE(NKH(1,np,nc,nr),SK_LONG_INT,NHP(np,nr),CONNID)
     '        .EQ.-1) GOTO 9999
          ENDDO
        ENDDO
      ENDDO !nr
      IF(USE_OPTI.GT.0) THEN
        IF(FSKWRITE(NMNO(1,0),SK_LONG_INT,1+NTOPTI,CONNID).EQ.-1)
     '    GOTO 9999
      ENDIF
      DO nb=1,NBFT
        DO mm=1,6
          IF(FSKWRITE(NNF(0,mm,nb),SK_LONG_INT,18,CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO
      ENDDO
      DO nf=1,NFT
        IF(FSKWRITE(NPF(1,nf),SK_LONG_INT,9,CONNID).EQ.-1) GOTO 9999
      ENDDO
      DO nef=1,MAX(NET(0),NFT)
        DO nb=1,NBFT
          IF(FSKWRITE(NPNE(1,nb,nef),SK_LONG_INT,NNT(nb),CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO
      ENDDO
      DO nrc=0,NRCM
        DO ny=1,NYM
          IF(FSKWRITE(NPNY(0,ny,nrc),SK_LONG_INT,7,CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO
      ENDDO
      IF(FSKWRITE(NRE,SK_LONG_INT,NET(0),CONNID).EQ.-1) GOTO 9999
      DO nef=1,MAX(NET(0),NFT)
        DO nb=1,NBFT
          DO nh=1,NH_LOC(0,0)
            IF(FSKWRITE(NVHE(1,nb,nh,nef),SK_LONG_INT,NNT(nb),CONNID)
     '        .EQ.-1) GOTO 9999
          ENDDO
        ENDDO
      ENDDO
      DO nr=0,NRT
        DO nc=1,NCM
          DO np=1,NPT(nr)
            IF(FSKWRITE(NVHP(1,np,nc,nr),SK_LONG_INT,NHP(np,nr),CONNID)
     '        .EQ.-1)GOTO 9999
          ENDDO
        ENDDO
      ENDDO !nr
      DO mm=1,2
        IF(FSKWRITE(NW(1,mm),SK_LONG_INT,NET(0),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO ne=1,NET(0)
        IF(FSKWRITE(NXI(-NIM,0,ne),SK_LONG_INT,2*NIM+1,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO ne=1,NET(0)
        DO nc=1,NCM
          DO nrc=0,NRCM
            DO nh=1,NH_LOC(0,0)
              IF(FSKWRITE(NYNE(1,nh,nrc,nc,ne),SK_LONG_INT,NAM,CONNID)
     '          .EQ.-1) GOTO 9999
            ENDDO
          ENDDO !nrc
        ENDDO
      ENDDO
      DO nr=1,NRT
        DO nc=1,NCM
          DO nrc=0,NRCM
            DO np=1,NPT(nr)
              DO nh=1,NHP(np,nr)
                DO nv=1,NVHP(nh,np,nc,nr)
                  IF(FSKWRITE(NYNP(1,nv,nh,np,nrc,nc,nr),SK_LONG_INT,
     '              NKH(nh,np,nc,nr),CONNID).EQ.-1) GOTO 9999
                ENDDO
              ENDDO
            ENDDO
          ENDDO !nrc
        ENDDO
      ENDDO !nr

C *** Real*8 Arrays
      DO ne=1,NET(0)
        IF(FSKWRITE(CE(1,ne),SK_DOUBLE_FLOAT,NMM,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO np=1,NPT(0)
        IF(FSKWRITE(CP(1,np),SK_DOUBLE_FLOAT,NMM,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO nb=1,NBT
        DO ng=1,NGT(nb)
          DO nu=1,NUT(nb)
            IF(FSKWRITE(PG(1,nu,ng,nb),SK_DOUBLE_FLOAT,NST(nb)+NAT(nb),
     '        CONNID).EQ.-1) GOTO 9999
          ENDDO
        ENDDO
      ENDDO
      DO nef=1,MAX(NET(0),NFT)
        DO nb=1,NBFT
          IF(FSKWRITE(SE(1,nb,nef),SK_DOUBLE_FLOAT,NST(nb)+NAT(nb),
     '      CONNID).EQ.-1) GOTO 9999
        ENDDO
      ENDDO
      DO nb=1,NBT
        IF(FSKWRITE(WG(1,nb),SK_DOUBLE_FLOAT,NGT(nb),CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO

C *** Logical Arrays
      DO mm=1,NIYFIXM
        IF(FSKWRITE(FIX(1,mm),SK_LONG_INT,NYM,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO

C     Send a flag string to check array transfer was OK
      TEMP_STR='ARRAY TRANSFER OK '
      L=FSKLEN(TEMP_STR)
      CALL FSKF2C(TEMP_STR,L,TEMP_STR_C)
      IF(FSKWRITE(L+1,SK_LONG_INT,1,CONNID).EQ.-1) GOTO 9999
      IF(FSKWRITE(TEMP_STR_C,SK_CHAR,L+1,CONNID).EQ.-1) GOTO 9999

      CALL EXITS('SEND_ARRAYS_ASSEMBLE5')
      RETURN
 9999 ERROR='>>Socket Error'
      CALL ERRORS('SEND_ARRAYS_ASSEMBLE5',ERROR)
      CALL EXITS('SEND_ARRAYS_ASSEMBLE5')
      RETURN 1
      END


