      SUBROUTINE SEND_DATA_ASSEMBLE5(CONNID,nr,nx,FEXT,XE,ZE,ZE1,
     '  ERROR,*)

C#### Subroutine: SEND_DATA_ASSEMBLE5
C###  Description:
C###    SEND_DATA_ASSEMBLE5 performs parallel processing for
C###    ASSEMBLE5. Sends current element data to
C###    element stiffness matrix calculating slave process.
C**** NOTE: changes to this code must be reflected in FE_PARALLEL.F

      IMPLICIT NONE
      INCLUDE 'fsklib.inc'
      INCLUDE 'geom00.cmn'
      INCLUDE 'loc00.cmn'
      INCLUDE 'loc00.inc'
!     Parameter List
      INTEGER CONNID,nr,nx
      REAL*8 FEXT(NIFEXTM,NGM),XE(NSM,NJM),ZE(NSM,NHM),ZE1(NSM,NHM)
      CHARACTER ERROR*(*)
!     Local Variables
      INTEGER ng,nhx,nj,njj1,njj2

      CALL ENTERS('SEND_DATA_ASSEMBLE5',*9999)

      DO ng=1,NGM
        IF(FSKWRITE(FEXT(1,ng),SK_DOUBLE_FLOAT,NIFEXTM,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO
      DO njj1=1,3
        DO njj2=1,NJ_LOC(njj1,0,nr)
          nj=NJ_LOC(njj1,njj2,nr)
          IF(FSKWRITE(XE(1,nj),SK_DOUBLE_FLOAT,NSM,CONNID).EQ.-1)
     '      GOTO 9999
        ENDDO !njj2
      ENDDO !njj1
      DO nhx=1,NH_LOC(0,nx)
        IF(FSKWRITE(ZE(1,nhx),SK_DOUBLE_FLOAT,NSM,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO !nhx
      DO nhx=1,NH_LOC(0,nx)
        IF(FSKWRITE(ZE1(1,nhx),SK_DOUBLE_FLOAT,NSM,CONNID).EQ.-1)
     '    GOTO 9999
      ENDDO !nhx

      CALL EXITS('SEND_DATA_ASSEMBLE5')
      RETURN
 9999 ERROR='>>Socket Error'
      CALL ERRORS('SEND_DATA_ASSEMBLE5',ERROR)
      CALL EXITS('SEND_DATA_ASSEMBLE5')
      RETURN 1
      END


