C news MPN 13-Sep-94: Parallel element stiffness matrix computations
      IF(KTYP1A.EQ.2) THEN  !parallel element stiffness matrix calcs
        NUMHOSTS_USED=MIN(NUMHOSTS,NEELEM(0,nr_solve))
        IF(AUTO_SPAWN) THEN  !Spawn processes on all remote machines
          DO nhost=1,NUMHOSTS_USED
            IF(.NOT.SOCKET_OPEN(nhost)) THEN !spawn proc unopened socket
C             Determine exec name (=image name without path)
              CALL STRING_TRIM(HOSTS(nhost),IBEG,IEND)
              CALL STRING_TRIM(IMAGE_NAME,IBEG1,IEND1)
              IF(OS_TYPE(1:4).EQ.'VMS ') THEN
C               master process is running on a VMS machine
                IBRA=CLOCAT(']',IMAGE_NAME(IBEG1:IEND1))
                IDOT=CLOCAT('.',IMAGE_NAME(IBRA+1:IEND1))
                EXEC_NAME=IMAGE_NAME(IBRA+1:IBRA+IDOT-1)
C               Set qualifiers required for process spawning
                QUAL1='/lowercase ' !UNIX login ids are lowercase
              ELSE IF(OS_TYPE(1:4).EQ.'UNIX') THEN
C               master process is running on a UNIX machine
                INDX=IEND1
                DO WHILE(INDX.GE.IBEG1.AND.IMAGE_NAME(INDX:INDX).NE.'/')
                  INDX=INDX-1
                ENDDO
                EXEC_NAME=IMAGE_NAME(INDX+1:IEND1)
                QUAL1='-n         '  !redirects input to /dev/null
              ENDIF
C             Set the remote process name
              IF(EXEC_NAME(1:3).EQ.'FEM'.OR.EXEC_NAME(1:2).EQ.'cm') THEN
C               Running global version of CMISS
                REMOTE_NAME='   cm_parallel'
              ELSE IF(EXEC_NAME(1:4).EQ.'MFEM'.OR.
     '          EXEC_NAME(1:4).EQ.'mycm') THEN
C               Running personal version of CMISS
                REMOTE_NAME=' mycm_parallel'
              ELSE
                ERROR='Weird image name'
                GO TO 9999
              ENDIF
C             Spawn command to fire off remote process
              WRITE(PORT_STR,'(I5)') IPORT(nhost)
              WRITE(CONNID_STR,'(I2)') ICONNID(nhost)
              COMMAND='rsh '//QUAL1(1:11)//HOSTS(nhost)(IBEG:IEND)
     '          //REMOTE_NAME(1:14)//' -connid '//CONNID_STR(1:2)
     '          //' -port '//PORT_STR(1:5)
              CALL DO_COMMAND(COMMAND,ERROR,*9999)
            ENDIF
          ENDDO !nhost
C         delay before continuing - to give remote processes
C         time to get ready to connect
          CALL SLEEPER(IDELAY_SOCKET)
        ENDIF !auto_spawn
C       Setup socket connections to each slave
        DO nhost=1,NUMHOSTS_USED
          IF(.NOT.SOCKET_OPEN(nhost)) THEN !socket not open so open it
            CALL STRING_TRIM(HOSTS(nhost),IBEG,IEND)
            WRITE(CHAR1,'(I5)') IPORT(nhost)
            WRITE(CHAR2,'(I3)') ICONNID(nhost)
            IF(FSKCONNECT(ICONNID(nhost),HOSTS(nhost),IPORT(nhost),3)
     '        .EQ.-1) THEN
              WRITE(OP_STRING,'('' Could not connect to process on '
     '          //HOSTS(nhost)(IBEG:IEND)//' through port '
     '          //CHAR1(1:5)//' and conn_id '//CHAR2(1:3)//''')')
              CALL WRITES(IODI,OP_STRING,ERROR,*9999)
              SOCKET_OPEN(nhost)=.FALSE.
            ELSE
              WRITE(OP_STRING,'('' Connected to process on '
     '          //HOSTS(nhost)(IBEG:IEND)//' through port '
     '          //CHAR1(1:5)//' and conn_id '//CHAR2(1:3)//''')')
              CALL WRITES(IODI,OP_STRING,ERROR,*9999)
              SOCKET_OPEN(nhost)=.TRUE.
            ENDIF
            GLOBAL_SENT(nhost)=.FALSE.
          ENDIF
C         Check if global information has been sent to slave processes
          IF(SOCKET_OPEN(nhost).AND.       !global info not sent to
     '       .NOT.GLOBAL_SENT(nhost)) THEN !HOSTS(nhost) yet so send it
C           signal to slave to reread global common blocks and arrays
            IF(FSKWRITE(REREAD_GLOBAL,SK_LONG_INT,1,ICONNID(nhost))
     '        .EQ.-1) GOTO 8888
            CALL CPU_TIMER(CPU_USER,TIME_START2)
            CALL SEND_COMMON_ASSEMBLE5(ICONNID(nhost),nx,HOSTS(nhost),
     '        ERROR,*9999)
            CALL CPU_TIMER(CPU_USER,TIME_STOP)
            ELAPSED_TIME=TIME_STOP(1)-TIME_START2(1)
            CALL STRING_TRIM(HOSTS(nhost),IBEG,IEND)
            WRITE(OP_STRING,'(/'' Sent common blocks to process on '
     '        //HOSTS(nhost)(IBEG:IEND)//' in '',D11.3,'' s'')')
     '        ELAPSED_TIME
            CALL WRITES(IODI,OP_STRING,ERROR,*9999)
            CALL CPU_TIMER(CPU_USER,TIME_START2)
            CALL SEND_ARRAYS_ASSEMBLE5(ICONNID(nhost),
     '        IBT,IDO,INP,NAN,NBH,NBJ,NBJF,NFF,NGAP,NHE,NHP,
     '        NKEF,NKH,NMNO,NNF,NPF,NPNE,NPNY,NRE,
     '        NVHE,NVHP,NW,NXI,NYNE,NYNP,
     '        CE,CP,PG,SE,WG,FIX,ERROR,*9999)
            CALL CPU_TIMER(CPU_USER,TIME_STOP)
            ELAPSED_TIME=TIME_STOP(1)-TIME_START2(1)
            CALL STRING_TRIM(HOSTS(nhost),IBEG,IEND)
            WRITE(OP_STRING,'('' Sent global arrays to process on '
     '        //HOSTS(nhost)(IBEG:IEND)//' in '',D11.3,'' s'')')
     '        ELAPSED_TIME
            CALL WRITES(IODI,OP_STRING,ERROR,*9999)
            GLOBAL_SENT(nhost)=.TRUE.
          ENDIF
        ENDDO !nhost
C       check that at least one slave has connected
        SLAVES=.FALSE.
        DO nhost=1,NUMHOSTS_USED
          IF(SOCKET_OPEN(nhost)) SLAVES=.TRUE.
        ENDDO !nhost
        IF(.NOT.SLAVES) THEN
          ERROR='Cannot solve as no slave machines connected'
          GO TO 9999
        ENDIF
      ENDIF
C newe

!news MPN 5-Sep-94: Parallel processing
 8888 ERROR='>>Socket Error'    !for socket errors close all sockets
      DO nhost=1,NUMHOSTS_USED
        IF(SOCKET_OPEN(nhost)) THEN
          IRET=FSKCLOSE(ICONNID(nhost)) !close socket
          IRET=IRET !assume IRET will be used...this line avoids errors
          SOCKET_OPEN(nhost)=.FALSE.
        ENDIF
        GLOBAL_SENT(nhost)=.FALSE.
      ENDDO
!newe
